/*
 * @Overview 공장/작업장 등록
 */

class Tb_factory_class {
  constructor(container) {
    let _this = this;
    _this.ajax_url = "./plant.ajax.php";
    this.tbList = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList() {
    const _this = this;
    const talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);

    const plantInput = document.querySelector("#factory_name").value;
    const useFlgCheckbox = document.querySelector("#use_flag").value;

    ajax_json({
      url: _this.ajax_url,
      data: {
        mode: "getPlantList",
        PLANT_NM: plantInput?plantInput:"",
        USE_FLG: useFlgCheckbox
      },
      success: (data) => {

        if(data.code) {
          this.tbList.setData(data.data);
          console.log(data.data)
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
      },
    });
    return true;
  }
  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   * @function 공장, 작업장, 사용 여부 필터링
   */
  setFilter() {


  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I", USE_FLG: "Y" },true);

  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);
      Tb_workPlace.getMainList(null);
    } else {
      this.tbList.deselectRow();
      tgt.select();
      Tb_workPlace.getMainList(tgt.getData().PLANT_CD);

    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    var editor = tgt.getColumn().getDefinition().editor;
    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        break;
      case "BIZ_AREA_NM":
        popBizArea({
          BIZ_AREA_CD: "BIZ_AREA_CD",
          BIZ_AREA_NM: "BIZ_AREA_NM",
        },tgt.getRow());
        
        break;
      case "ZIP_CD":
        tgt.getData()._STATUS_ = tgt.getData()._STATUS_ || "U";
        new daum.Postcode({
          theme: {
            searchBgColor: "#ECECEC", //검색창 배경색
            queryTextColor: "#000" //검색창 글자색
          },
          oncomplete: function(data) {
            let zipcode = "", address = "";
            if( data ){
              console.log(data)
              switch( data.userSelectedType ){
                case "R": //도로명 클릭
                address = data.roadAddress;
                break;
                case "J": //지번 클릭
                address = data.jibunAddress;
                break;
              }
              zipcode = data.zonecode;
              tgt.getRow().update({ZIP_CD: zipcode, ADDR: address});
              tgt.getElement().classList.add('tabulator-editable');
            }
          }
        }).open({popupTitle:'쿨스 우편번호 검색', popupKey:'Kuls'});
        
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
      default:
        if (!editor) {
          this.rowClick && this.rowClick(e, tgt.getRow());

        }
        break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
  putData() {
  // let _this = this;

    return new Promise((resolve, reject) => {
      // 저장 시 상태 변화 없는 row 요청 X
      if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
        this.getMainList();
        resolve(false);
        return false;
      }


      const blankObj = [];
      const reqData = [];

      this.tbList.getRows().forEach(row => {
        if(row.getData()['_STATUS_']){
          if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'USE_FLG').every(key => {

            const value = row._row.data[key];
            return (value === undefined || value === '');
          })){
            blankObj.push(row);
          }else{
            reqData.push(row.getData());
          }
        }
      })


      const postdata = reqData.length == 0 ? false : {
        'mode': 'putPlant',
        'reqdata': JSON.stringify(reqData),
      };

      if(!postdata){
        this.getMainList();
        resolve(false);
        return false;
      };

      if(blankObj.length !== 0){
        kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
          ajax_json({
            url: this.ajax_url,
            data: postdata,
            success: (data)=>{
              if (data.code) {
                kuls_success("저장되었습니다.");
                this.getMainList();
                resolve(true);
              }else{
                kuls_alert(data.mesg);
                reject(new Error(data.mesg));
              }
            },
            error: function (request, status, error) {
              kuls_alert(error.message);
              reject(new Error(error.message));
            },
            complete: function () {
            }
          });

        },()=>{
          blankObj.forEach(row=>{
            row.getElement().classList.add("blank-row")
          })
        })
      }else{
        ajax_json({
          url: this.ajax_url,
          data: postdata,
          success: (data)=>{
            if (data.code) {
              kuls_success("저장되었습니다.");
              this.getMainList();
              resolve(true);
            }else{
              kuls_alert(data.mesg);
              reject(new Error(data.mesg));
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
            reject(new Error(error.message));
          },
          complete: function () {}
        });
      }
 
    })

  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 40, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum", title: "NO", width: 40 },
      { field: "PLANT_CD", title: "공장 코드", width: 70,
        editor: tb_custom_editor.pkCode,
        editorParams: {type: 'upper'}, 
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
      },
      { field: "PLANT_NM", title: "공장명", width: 70, editor:tb_custom_editor.upper, hozAlign:"left",
        cssClass: "editable-cell"
      },
      { field: "ZIP_CD", title: "공장<br>우편번호", width: 70, cssClass:"tabulator-editable" },
      { field: "ADDR", title: "공장 주소", width: 300, hozAlign:"left"},
      { field: "BIZ_AREA_NM", title: "사업장명", width: 80, hozAlign:"left", cssClass:"editable-cell" },
      { field: "BIZ_AREA_CD", title: "사업장코드", visible:false},
      { field: "REMK", title: "비고", width: 200, editor:"input",hozAlign:"left", cssClass:"tabulator-editable" },
      { field: "USE_FLG", title: "사용", width: 50, cssClass:"tabulator-editable", formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: {checkval:'Y'} },
    ];
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      this.getMainList();
      
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        this.getMainList && this.getMainList();
        Tb_workPlace.getMainList && Tb_workPlace.getMainList();
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        this.putData && this.putData().then(()=>{

          Tb_workPlace.putData && Tb_workPlace.putData();
        })
        
      });
    });
  }
}

/*
 * @Overview 작업장 관리
 */
class Tb_workPlace_class {
  constructor(container) {
    this.ajax_url = "./plant.ajax.php";
    this.tbList = "";
    this.code = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList(code) {
    this.code = code;

    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);
    const useFlgCheckbox = document.querySelector("#use_flag").value;

    ajax_json({
      url: this.ajax_url,
      
      data: { mode: "getWcList", PLANT_CD: code ,USE_FLG:useFlgCheckbox},
      success: (data) => {
        if(data.code) {
          
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
      },
    });
    return true;
  }

 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
  putData() {
    // 저장 시 상태 변화 없는 row 요청 X
    if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
      this.getMainList(this.code);
      return false;
    }


    const blankObj = [];
    const reqData = [];

    this.tbList.getRows().forEach(row => {

      if(row.getData()['_STATUS_']){
        if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'USE_FLG' && key !== 'PLANT_CD' ).every(key => {

          const value = row._row.data[key];
          return (value === undefined || value === '');
        })){
          blankObj.push(row);
        }else{
          reqData.push(row.getData());
        }
      }
    })


    const postdata = reqData.length == 0 ? false : {
      'mode': 'putWc',
      'reqdata': JSON.stringify(reqData),
    };

    if(!postdata){
      this.getMainList(this.code);
      return false;
    };

    if(blankObj.length !== 0){
      kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
        ajax_json({
          url: this.ajax_url,
          data: postdata,
          success: (data)=>{
            if (data.code) {
              kuls_success("저장되었습니다.");
              this.getMainList(this.code);
            }else{
              kuls_alert(data.mesg);
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
          },
          complete: function () {
          }
        });

      },()=>{
        blankObj.forEach(row=>{
          row.getElement().classList.add("blank-row")
        })
      })
    }else{
      ajax_json({
        url: this.ajax_url,
        data: postdata,
        success: (data)=>{
          if (data.code) {
            kuls_success("저장되었습니다.");
            this.getMainList(this.code);
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    
    }

  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    if(this.code){
      this.tbList.addRow({ _STATUS_: "I", PLANT_CD: this.code, USE_FLG: "Y" },true);
    }else{
      kuls_alert("공장을 선택해주세요")
    }
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);

    } else {
      tgt.select();

    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {

    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.setValue(tgt.getValue() === "Y" ? "N" : "Y");
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum", title: "NO", width: 50 },
      { field: "WC_CD", title: "작업장 코드", width: 150,
        editor: tb_custom_editor.upper,
        editable: (cell) => {
          const val = cell.getData();
          return val._STATUS_ === "I";
        },
      },
      { field: "WC_NM", title: "작업장명", width: 150, editor:"input",
        cssClass: "editable-cell"
      },
      { field: "PLANT_CD", title: "공장코드", visible: false },
      { field: "USE_FLG", title: "사용", width: 50, cssClass:"tabulator-editable", formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: {checkval:'Y'} },
    ];
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });


    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      // this.getMainList();
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = "";
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
  }
}





const Tb_factory = new Tb_factory_class("#main_table");
Tb_factory.init();
const Tb_workPlace = new Tb_workPlace_class("#sub_table");
Tb_workPlace.init();
